'
' DV32 General 2.0
' API declarations
' Copyright (c) 1997,1999 Patrice TERRIER.
'

TYPE DVALL
    BitMap    AS LONG     ' a Bitmap handle to be displayed.
    Icon      AS LONG     ' an icon handle to be displayed.
    Fore      AS LONG     ' the foreground color to use.
    Back      AS LONG     ' the background color to use.
    Edge      AS LONG     ' the frame border to use.
    Print3D   AS INTEGER  ' the text effect %DV_3DIN or %DV_3DOUT to use.
    Just      AS BYTE     ' the %DV_CENTERED or 0 for left justified.
    Modal     AS BYTE     ' the modal flag.
    ButFocus  AS BYTE     ' the default button focus.
    Effect    AS BYTE     ' %DV_PULSE %DV_MARQUEE %DV_CENTERED caption effect.
    X         AS INTEGER  ' Left X coordinate for text display
    Y         AS INTEGER  ' Upper Y coordinate for text display
    Isize     AS INTEGER  ' Input size length in characters (alias Lq)
    Iwidth    AS INTEGER  ' Input box width in pixels
    IHeight   AS INTEGER  ' Input box height in pixels
    Itype     AS INTEGER  ' Input type (alias Qod)
    ReadOnly  AS INTEGER  ' Input ES_READONLY on or off
    Iclass    AS BYTE     ' Input 1 = combo, 2 updn
    MinV      AS INTEGER  ' Input UpDn Min value
    MaxV      AS INTEGER  ' Input UpDn Max value
    SeedV     AS INTEGER  ' Input UpDn Seed value
    hEdit     AS LONG     ' Input returns the true edit handle (combo)
    hTitle    AS LONG     ' Input returns the input title handle
    ButEscape AS BYTE     ' the default button escape.
    Button    AS BYTE     ' Flag to use a resource button.
    Tile      AS BYTE     ' Tile painting mode on/off
END TYPE

TYPE IDVALL              ' Input field for database
    Itype    AS INTEGER  ' Input type (alias Qod)
    Isize    AS INTEGER  ' Input size length in characters (alias Lq)
    Iwidth   AS INTEGER  ' Input box width in pixels
    IHeight  AS INTEGER  ' Input box height in pixels
    ReadOnly AS INTEGER  ' Input ES_READONLY on or off
    X        AS INTEGER  ' Left X coordinate for text display
    Y        AS INTEGER  ' Upper Y coordinate for text display
    Edge     AS LONG     ' the frame border to use.
    Fore     AS LONG     ' the foreground color to use.
    Back     AS LONG     ' the background color to use.
    MinV     AS INTEGER  ' Input UpDn Min value
    MaxV     AS INTEGER  ' Input UpDn Max value
    SeedV    AS INTEGER  ' Input UpDn Seed value
    Iclass   AS BYTE     ' Input 1 combodropdown, 2 updn, 10 combodropdownlist
    hEdit    AS LONG     ' Input returns the true edit handle (combo)
    hTitle   AS LONG     ' Input returns the input title handle
    offset   AS INTEGER  ' Offset inside of the record buffer.
    Search   AS BYTE     ' Search flag 1-9 (1-5 alpha, 5-6 num)
END TYPE

'----------------------------- DV32GN20 constants ---------------------------

%DV_PULSE = 1
%DV_MARQUEE = 2
%DV_CENTERED = 3
%DV_3DIN = 1
%DV_3DOUT = -1

%IC_DRIVE = 7
%IC_HARDDISK = 8
%IC_CDROM = 9
%IC_DIROPEN = 10
%IC_DIR = 11
%IC_DV32 = 12

'----------------------------------------------------------------------------
DECLARE FUNCTION dvBtClose& LIB "DVSKGEN.DLL" (hBtFile&)
DECLARE FUNCTION dvBtDelete& LIB "DVSKGEN.DLL" (BYVAL hBtFile&, RKey$, Record&, BtErr&)
DECLARE FUNCTION dvBtFirst& LIB "DVSKGEN.DLL" (BYVAL hBtFile&, RKey$, Record&, BtErr&)
DECLARE FUNCTION dvBtInsert& LIB "DVSKGEN.DLL" (BYVAL hBtFile&, RKey$, Record&, BtErr&)
DECLARE FUNCTION dvBtKeyNbr& LIB "DVSKGEN.DLL" (BYVAL hBtFile&)
DECLARE FUNCTION dvBtLast& LIB "DVSKGEN.DLL" (BYVAL hBtFile&, RKey$, Record&, BtErr&)
DECLARE FUNCTION dvBtMatch& LIB "DVSKGEN.DLL" (BYVAL hBtFile&, RKey$, Record&, BtErr&)
DECLARE FUNCTION dvBtNext& LIB "DVSKGEN.DLL" (BYVAL hBtFile&, RKey$, Record&, BtErr&)
DECLARE FUNCTION dvBtOpen& LIB "DVSKGEN.DLL" (BYVAL FilName$, BYVAL Klen&, hBtFile&, BtErr&)
DECLARE FUNCTION dvBtPrev& LIB "DVSKGEN.DLL" (BYVAL hBtFile&, RKey$, Record&, BtErr&)
DECLARE FUNCTION dvBtSearch& LIB "DVSKGEN.DLL" (BYVAL hBtFile&, RKey$, Record&, BtErr&)
DECLARE FUNCTION dvBufin$ LIB "DVSKGEN.DLL" (FilName$, Done&)
DECLARE FUNCTION dvCommand$ LIB "DVSKGEN.DLL" (BYVAL ConvertCase?)
DECLARE FUNCTION dvConvert$ LIB "DVSKGEN.DLL" (BYVAL Text$, BYVAL ConvertMode?)
DECLARE SUB KillObject LIB "DVSKGEN.DLL" (hObject&)
DECLARE SUB dvDskPath LIB "DVSKGEN.DLL" (Dsk$, Path$)
DECLARE FUNCTION dvExeName$ LIB "DVSKGEN.DLL" ()
DECLARE FUNCTION dvExist& LIB "DVSKGEN.DLL" (BYVAL FileSpec$)
DECLARE SUB dvFClose LIB "DVSKGEN.DLL" (hFile&)
DECLARE FUNCTION dvFGet& LIB "DVSKGEN.DLL" (BYVAL hFile&, Buf$)
DECLARE FUNCTION dvFGetAt& LIB "DVSKGEN.DLL" (BYVAL hFile&, BYVAL PosByte&, Buf$)
DECLARE FUNCTION dvFGetR& LIB "DVSKGEN.DLL" (BYVAL hFile&, Buf$, BYVAL Record&)
DECLARE FUNCTION dvFlof& LIB "DVSKGEN.DLL" (BYVAL hFile&)
DECLARE FUNCTION dvFlush& LIB "DVSKGEN.DLL" (BYVAL hFile&)
DECLARE FUNCTION dvFOpen& LIB "DVSKGEN.DLL" (BYVAL FilName$, BYVAL AccessMode&, BYVAL ShareMode&, hFile&)
DECLARE FUNCTION dvFPut& LIB "DVSKGEN.DLL"  (BYVAL hFile&, Buf$)
DECLARE FUNCTION dvFPutAt& LIB "DVSKGEN.DLL" (BYVAL hFile&, BYVAL PosByte&, Buf$)
DECLARE FUNCTION dvFPutR& LIB "DVSKGEN.DLL" (BYVAL hFile&, Buf$, BYVAL Record&)
DECLARE FUNCTION dvFSeek& LIB "DVSKGEN.DLL" (hFile&, BYVAL PosByte&)
DECLARE FUNCTION dvInstr2& LIB "DVSKGEN.DLL" (BYVAL FromPos&, BYVAL Item$, BYVAL Search$)
DECLARE FUNCTION dvInstrB& LIB "DVSKGEN.DLL" (BYVAL FromPos&, BYVAL Item$, BYVAL Search$)
DECLARE FUNCTION dvKillFile& LIB "DVSKGEN.DLL" (FilName$)
DECLARE FUNCTION dvFLock& LIB "DVSKGEN.DLL" (BYVAL hFile&, BYVAL OffSet&, BYVAL Length&)
DECLARE FUNCTION dvMacte$ LIB "DVSKGEN.DLL" (BYVAL Acte??, Mact$())
DECLARE FUNCTION dvMenu& LIB "DVSKGEN.DLL" (BYVAL BarMnu$, PopMnu$(), Mact$())
DECLARE SUB dvReadM LIB "DVSKGEN.DLL" (FilName$, BarMnu$, PopMnu$(), Mact$(), Done&)
DECLARE SUB dvReadStr LIB "DVSKGEN.DLL" (ConfigFile$, cfgString$(), Done&)
DECLARE FUNCTION dvSetEof& LIB "DVSKGEN.DLL" (BYVAL hFile&)
DECLARE FUNCTION dvSetEofAt& LIB "DVSKGEN.DLL" (BYVAL hFile&, BYVAL PosByte&)
DECLARE FUNCTION dvFSetSize& LIB "DVSKGEN.DLL" (BYVAL FilName$, BYVAL PosByte&)
DECLARE SUB dvSplitN LIB "DVSKGEN.DLL" (BYVAL FullName$, PathName$, FilName$)
DECLARE SUB dvSplitS LIB "DVSKGEN.DLL" (BYVAL Expr$, Expr$(), BYVAL Delim$, BYVAL hWnd&, BYVAL hFont&, MaxInC&, MaxInF&)
DECLARE FUNCTION dvUcase$ LIB "DVSKGEN.DLL" (BYVAL StringToConvert$)
DECLARE FUNCTION dvFUnLock& LIB "DVSKGEN.DLL" (BYVAL hFile&, BYVAL OffSet&, BYVAL Length&)
DECLARE SUB GetTextExtent LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL hFont&, BYVAL stText$, stWidth&, stHeight&)

' DVDK
DECLARE FUNCTION dvLoadBmp& LIB "DVSKGEN.DLL" (BYVAL FileBmpName$)
DECLARE FUNCTION dvLoadIcon& LIB "DVSKGEN.DLL" (BYVAL FileIconName$)
DECLARE SUB dvPrint LIB "DVSKGEN.DLL" (BYVAL HDCorHWND&, BYVAl Txt$, BYVAL X&, BYVAL Y&, BYVAL Fore&, BYVAL Back&, BYVAL hFont&, BYVAL BkMode&, BYVAL hWndORhDC?)
DECLARE SUB dvPrint3D LIB "DVSKGEN.DLL" (BYVAL HDCorHWND&, BYVAl Txt$, BYVAL X&, BYVAL Y&, BYVAL Fore&, BYVAL Back&, BYVAL hFont&, BYVAL BkMode&, BYVAL hWndORhDC?)

DECLARE SUB GetPixmapSize LIB "DVSKGEN.DLL" (BYVAL hBmp&, xWidth&, yHeight&)
DECLARE SUB PaintPixMap LIB "DVSKGEN.DLL" (BYVAL hWnd&, hBmp&, BYVAL X&, BYVAL Y&, BYVAL xWidth&, BYVAL yHeight&, BYVAL ROP&, BYVAL Flag?, BYVAL hWndORhDC?)
DECLARE SUB PutPixMap LIB "DVSKGEN.DLL" (BYVAL hWnd&, hBmp&, BYVAL X&, BYVAL Y&, BYVAL xWidth&, BYVAL yHeight&, BYVAL xOffset&, BYVAL yOffset&, BYVAL ROP&, BYVAL Flag?, BYVAL hWndORhDC?)
DECLARE SUB ZoomPixMap LIB "DVSKGEN.DLL" (BYVAL hWnd&, hBmp&, BYVAL X&, BYVAL Y&, BYVAL xWidth&, BYVAL yHeight&, BYVAL ROP&, BYVAL zoomX&, BYVAL zoomY&, BYVAL zoomWidth&, BYVAL zoomHeight&, BYVAL Flag?, BYVAL hWndORhDC?)

DECLARE SUB SetWindowIcon LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL hIcon&)
DECLARE SUB dvFillRect LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL X&, BYVAL Y&, BYVAL xWidth&, BYVAL yHeight&, BYVAL nColor&, BYVAL hWndORhDC?)
DECLARE SUB dvDrawEdge LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL X&, BYVAL Y&, BYVAL xWidth&, BYVAL yHeight&, BYVAL edge&, BYVAL bfFlags&, BYVAL hWndORhDC?)
DECLARE SUB dvLine LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL Xstart&, BYVAL Ystart&, BYVAL Xend&, BYVAL Yend&, BYVAL Style&, BYVAL Size?, BYVAL nColor&, BYVAL hWndORhDC?)
DECLARE SUB SetCTLFont LIB "DVSKGEN.DLL" (BYVAL hCTL&, BYVAL hFont&)
DECLARE SUB SetCTLText LIB "DVSKGEN.DLL" (BYVAL hCTL&, BYVAL Text$)
DECLARE FUNCTION IconSystem& LIB "DVSKGEN.DLL" (BYVAL Constant&)

DECLARE FUNCTION dvNotify& LIB "DVSKGEN.DLL" (BYVAL hOwner&, BYVAL hFont&, BYVAL Caption$, BYVAL nNotify$, BYVAL Button$, dv AS DVALL)

DECLARE SUB dvSetClassBackground LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL nColor&)
DECLARE SUB dvSetClassIcon LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL hIcon&)

DECLARE FUNCTION dvDskList$ LIB "DVSKGEN.DLL" ()
DECLARE FUNCTION dvInset& LIB "DVSKGEN.DLL" (BYVAL Mask&, BYVAL SetNumber&)
DECLARE FUNCTION dvDirCount& LIB "DVSKGEN.DLL" (BYVAL Mask$, BYVAL Attr&)
DECLARE FUNCTION dvIcon& LIB "DVSKGEN.DLL" (BYVAL Icon&)
DECLARE FUNCTION dvWindir$ LIB "DVSKGEN.DLL" ()

DECLARE FUNCTION dvPickF? LIB "DV32DL20.DLL" (BYVAL hOwner&, BYVAL FullSpec$, _
                 BYVAL Caption$, BYVAL Filter$, BYVAL Button$, _
                 BYVAL ListCaption$, BYVAL DirCaption$, BYVAL FilterCaption$, _
                 BYVAL PicCaption$, BYVAL StaticCaption$, _
                 BYVAL BoxMode&, PickFile$, EditData$)

DECLARE FUNCTION dvLoadENHmetafile& LIB "DVSKGEN.DLL" (BYVAL Metafile$)

' Undocumented features ....................................................
DECLARE SUB dvPickInFile LIB "DV32DL20.DLL" (Item$, BYVAL RW&)
DECLARE SUB dvPickLastFile LIB "DV32DL20.DLL" (Item$, BYVAL RW&)

DECLARE FUNCTION dbName$ LIB "DVSKGEN.DLL" (BYVAL MyName$, BYVAL MyChar?)

DECLARE SUB LimitTextEdit LIB "DVSKGEN.DLL" (BYVAL hEdit&, BYVAL MaxLength&)
DECLARE FUNCTION AddItemODListBox& LIB "DVSKGEN.DLL" (BYVAL hList&, BYVAL hBitmap&)
DECLARE FUNCTION AddStringListBox& LIB "DVSKGEN.DLL" (BYVAL hList&, BYVAL Text$)
DECLARE FUNCTION GetCurSelCombo& LIB "DVSKGEN.DLL" (BYVAL hCombo&)
DECLARE FUNCTION GetCurSelListBox& LIB "DVSKGEN.DLL" (BYVAL hList&)
DECLARE FUNCTION GetAnchorListBox& LIB "DVSKGEN.DLL" (BYVAL hList&)
DECLARE FUNCTION GetTextListBox$ LIB "DVSKGEN.DLL" (BYVAL hListBox&, BYVAL Item&)
DECLARE SUB InsertItemListBox LIB "DVSKGEN.DLL" (BYVAL hList&, BYVAL Text$, BYVAL Index&)
DECLARE SUB ResetListBox LIB "DVSKGEN.DLL" (BYVAL hList&)
DECLARE SUB SelectListBox LIB "DVSKGEN.DLL" (BYVAL hListBox&, BYVAL Item&)
DECLARE SUB SetListBoxItemHeight LIB "DVSKGEN.DLL" (BYVAL hListBox&, BYVAL CharHeight&)

DECLARE FUNCTION AddStringCombo& LIB "DVSKGEN.DLL" (BYVAL hCombo&, BYVAL Text$)
DECLARE FUNCTION GetTextCombo$ LIB "DVSKGEN.DLL" (BYVAL hCombo&, BYVAL Item&)
DECLARE SUB InsertItemCombo LIB "DVSKGEN.DLL" (BYVAL hCombo&, BYVAL Text$, BYVAL Index&)
DECLARE SUB SelectCombo LIB "DVSKGEN.DLL" (BYVAL hCombo&, BYVAL ComboItem&)

DECLARE FUNCTION GetCTLText$ LIB "DVSKGEN.DLL" (BYVAL hCTL&)

DECLARE SUB dvIconise LIB "DVSKGEN.DLL" (BYVAL xPic&, BYVAL yPic&, BYVAL xCell&, BYVAL yCell&, xPos&, yPos&, xSize&, ySize&)
DECLARE FUNCTION LeadExt$ LIB "DVSKGEN.DLL" ()

DECLARE FUNCTION dvFLoc& LIB "DVSKGEN.DLL" (hFile&)

DECLARE FUNCTION IsFrench& LIB "DVSKGEN.DLL" ()
'DECLARE FUNCTION dvDateOnly& LIB "DVSKGEN.DLL" (BYVAL wParam&, BYVAL lParam&)
'DECLARE FUNCTION dvIntOnly& LIB "DVSKGEN.DLL" (BYVAL wParam&, BYVAL lParam&)
'DECLARE FUNCTION dvNumOnly& LIB "DVSKGEN.DLL" (BYVAL wParam&, BYVAL lParam&)
'DECLARE FUNCTION dvUcaseOnly& LIB "DVSKGEN.DLL" (BYVAL wParam&, BYVAL lParam&)
DECLARE FUNCTION dvUpDnCtrl& LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL X&, BYVAL Y&, BYVAL xW&, BYVAL yH&, BYVAL MinV&, BYVAL MaxV&, BYVAL SeedV&, BYVAL ID&)
DECLARE FUNCTION dvInput& LIB "DVSKGEN.DLL" (BYVAL hOwner&, BYVAL hFont&, BYVAL Caption$, BYVAL Text$, BYVAL ID&, dv AS DVALL)
DECLARE SUB dvPrintDlgEx LIB "DVSKGEN.DLL" (PrinterName$, DeviceName$, nPort$, BYVAL RW&)
DECLARE FUNCTION dvCode$ LIB "DVSKGEN.DLL" (BYVAL L$)
DECLARE SUB dvSequence LIB "DVSKGEN.DLL" (Item$)
DECLARE FUNCTION dvMmLib& LIB "DVSKGEN.DLL" (zLibName AS ASCIIZ, zFileName AS ASCIIZ, BYVAL Act&)
DECLARE SUB dvMmText LIB "DVSKGEN.DLL" (TxtName$, BYVAL RW&)
DECLARE SUB dvMmName LIB "DVSKGEN.DLL" (MlmName$, BYVAL RW&)
DECLARE SUB dvTextColor LIB "DVSKGEN.DLL" (BYVAL hObject&, BYVAL nColor&)
DECLARE SUB dvBackColor LIB "DVSKGEN.DLL" (BYVAL hObject&, BYVAL nColor&)
DECLARE SUB dvKeybHook LIB "DVSKGEN.DLL" (BYVAL hObject&, BYVAL Hook&)
DECLARE SUB dvFilterChoice LIB "DV32DL20.DLL" (Item$, BYVAL RW&)
DECLARE FUNCTION dvInputBox& LIB "DVSKGEN.DLL" (BYVAL hOwner&, BYVAL hFont&, BYVAL Caption$, BYVAL nNotify$, BYVAL Button$, UserInput$, dv AS DVALL)
DECLARE FUNCTION dvDateInv$ LIB "DVSKGEN.DLL" (BYVAL MyDate$)
DECLARE FUNCTION dvInvDate$ LIB "DVSKGEN.DLL" (BYVAL MyDate$)
DECLARE FUNCTION dvWinErr$ LIB "DVSKGEN.DLL" (BYVAL X&)
DECLARE FUNCTION OsNT& LIB "DVSKGEN.DLL" ()
DECLARE FUNCTION dvMakeDir& LIB "DVSKGEN.DLL" (BYVAL Rep$)
DECLARE FUNCTION dvEncrypt$ LIB "DVSKGEN.DLL" (BYVAL Buffer$)
DECLARE FUNCTION dvDecrypt$ LIB "DVSKGEN.DLL" (BYVAL Buffer$)

'-----------------------------------------------------------
DECLARE FUNCTION GetBValue? LIB "DVSKGEN.DLL" (BYVAL nColor&)
DECLARE FUNCTION GetGValue? LIB "DVSKGEN.DLL" (BYVAL nColor&)
DECLARE FUNCTION GetRValue? LIB "DVSKGEN.DLL" (BYVAL nColor&)

DECLARE FUNCTION dvBut3D& LIB "DVSKGEN.DLL" (BYVAL hOwner&, BYVAL Text$, BYVAL hFont&, BYVAL xLeft&, BYVAL yLeft&, BYVAL btWidth&, BYVAL btHeight&, BYVAL ButID&, dv AS DVALL)
DECLARE SUB dvDotRect LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL X1&, BYVAL Y1&, BYVAL xWidth&, BYVAL yHeight&, BYVAL nColor&, BYVAL hWndORhDC?)
DECLARE FUNCTION dvFileSize&& LIB "DVSKGEN.DLL" (BYVAL FilName$)

DECLARE FUNCTION dvSysdir$ LIB "DVSKGEN.DLL" ()
DECLARE FUNCTION dvFindF$ LIB "DVSKGEN.DLL" (BYVAL FilName$)
DECLARE FUNCTION dvRadical$ LIB "DVSKGEN.DLL" (BYVAL Default$)
DECLARE SUB dvGetDefaultPrinter LIB "DVSKGEN.DLL" (Driver$, Device$, nPort$)
DECLARE SUB dvEnumPrinter LIB "DVSKGEN.DLL" (Driver$())
DECLARE SUB dvGetPrinter LIB "DVSKGEN.DLL" (BYVAL Driver$, Device$, nPort$)

DECLARE FUNCTION dvDiskFree&& LIB "DVSKGEN.DLL" (BYVAL DSK$)
DECLARE FUNCTION dvDiskSize&& LIB "DVSKGEN.DLL" (BYVAL DSK$)
DECLARE FUNCTION dvName& LIB "DVSKGEN.DLL" (BYVAL OldName$, BYVAL NewName$)
DECLARE FUNCTION dvPrintDlg& LIB "DVSKGEN.DLL" (BYVAL hOwner&)

DECLARE SUB dvProgress LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL Percent&, BYVAL ColorTxt&, BYVAL Fore&, BYVAL Back&, BYVAL X&, BYVAL Y&, BYVAL Size&)
DECLARE FUNCTION dvCrunch& LIB "DVSKGEN.DLL" (Expr$, BYVAL Char?)
DECLARE FUNCTION dvCursorWait& LIB "DVSKGEN.DLL" ()
DECLARE SUB dvShell LIB "DVSKGEN.DLL" (BYVAL CmdLine$, BYVAL ShowWind&, BYVAL TimeLimit&)
DECLARE FUNCTION dvSetBufinChar$ LIB "DVSKGEN.DLL" (BYVAL Char$)

DECLARE SUB dvPickFilter LIB "DV32DL20.DLL" (Item$, BYVAL RW&)
DECLARE FUNCTION dvPickMulti& LIB "DV32DL20.DLL" (BYVAL nEnable&)

'DECLARE SUB dvInitImgDLL LIB "imgdll.dll" ALIAS "ImgDLLStringInitDLL" (BYVAL initString$)
'DECLARE FUNCTION dvGif2Bmp24& LIB "imgdll.dll" ALIAS "ImgDLLSaveRGBToBMP24" (BYVAL filename As String, BYVAL pBuf&, BYVAL lWidth&, BYVAL lHeight&)
'DECLARE FUNCTION dvReadGIF& LIB "imgdll.dll" ALIAS "ImgDLLReadRGBFromGIF" (BYVAL FilName$, lwidth&, lheight&, pTranscolor&)

DECLARE FUNCTION dvGif2Bmp24& LIB "dv32gb20.dll" ALIAS "ImgDLLSaveRGBToBMP" (BYVAL filename As String, BYVAL pBuf&, BYVAL lWidth&, BYVAL lHeight&)
DECLARE FUNCTION dvReadGIF& LIB "dv32gb20.dll" ALIAS "ImgDLLReadRGBFromGIF" (BYVAL FilName$, lwidth&, lheight&, pTranscolor&)

DECLARE FUNCTION dvLongFormat$ LIB "DVSKGEN.DLL" (BYVAL BigNumber&&)
DECLARE FUNCTION dvProgress32& LIB "DVSKGEN.DLL" (BYVAL hOwner&, BYVAL ID&, BYVAL xP&, BYVAL yP&, BYVAL pSize&)

DECLARE SUB CenterWind LIB "DVSKGEN.DLL" (BYVAL hOwner&, BYVAL Xout&, BYVAL Yout&, X&, Y&)
DECLARE SUB dvBeep LIB "DVSKGEN.DLL" ()
DECLARE FUNCTION dvToJul& LIB "DVSKGEN.DLL" (BYVAL D$)
DECLARE SUB dvPrint3DU LIB "DVSKGEN.DLL" (BYVAL HDCorHWND&, BYVAL Txt$, BYVAL X&, BYVAL Y&, BYVAL Fore&, BYVAL Back&, BYVAL hFont&, BYVAL BkMode&, BYVAL hWndORhDC?)
DECLARE FUNCTION dvTaskBar& LIB "DVSKGEN.DLL" ()
DECLARE FUNCTION dvDefaultFont& LIB "DVSKGEN.DLL" ()

DECLARE SUB dvUseFilter LIB "DV32DL20.DLL" (Item$, BYVAL RW&)
DECLARE FUNCTION dvUser$ LIB "DV32LN20.DLL" ()
DECLARE FUNCTION dvBitColor& LIB "DVSKGEN.DLL" ()
DECLARE SUB dvCursorStd LIB "DVSKGEN.DLL" ()

DECLARE FUNCTION dvNotIconise& LIB "DV32DL20.DLL" (BYVAL Done&)

DECLARE FUNCTION dvState3D$ LIB "DVSKGEN.DLL" ()

DECLARE FUNCTION dvPaintMessage& LIB "DVSKGEN.DLL" (BYVAL hWnd&, BYVAL Msg&, BYVAL wParam&, BYVAL lParam&)

