'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                 SKWEBBR                                  |
'|                                                                          |
'| This example shows how to use a Universal Browser in a "skined" window.  |
'|                                                                          |
'|   It is uses both the great COM/ActiveX work done by Philippe Monteil    |
'|                       and my new "Skin Engine".                          |
'|                                                                          |
'|        If you enjoy using it, please tell it to other programmers.       |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|            8 Domaine de Rochagnon. 38800 Champagnier  FRANCE             |
'|                       http://www.zapsolution.com                         |
'|                    E-mail: pterrier@zapsolution.com                      |
'|                                                                          |
'|                   copyright (c) 1999 Patrice TERRIER                     |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                          JAZZAge Software SARL                           |
'|                        http://www.jazzagesoft.com                        |
'|         SKWEBBR.BAS is adpated from the original TWEBBR.BAS from         |
'|                             Philippe Monteil                             |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 11-29-1999                         |
'|                        Last revised : 11-29-1999                         |
'+--------------------------------------------------------------------------+


#COMPILE EXE

#INCLUDE "WIN32API.inc"
#INCLUDE "COMDLG32.INC"
#INCLUDE "STDOLE32.INC"
#INCLUDE "JACOMPB.bas"
#INCLUDE "JAOCX20.inc"
#INCLUDE "SKENGINE.INC"
#RESOURCE "SKWEBBR.PBR"

GLOBAL zTruePath AS ASCIIZ * 128
GLOBAL hInst&, hFont&, Radical$
GLOBAL hFrame&, hMenu&, hCTL&, hStatus&
GLOBAL sk AS SKALL
GLOBAL Mact$(), cfgStr$()
GLOBAL zTmp AS ASCIIZ * 256
GLOBAL ScrWidth&, ScrHeight&
GLOBAL gActiveX???

GLOBAL ofn AS OPENFILENAME

%MAX_FNAME = 256
%MAX_EXT   = 3

%Compile_SYSInfoISysInfo = 1
#INCLUDE "SHDOCVW.BAS"

SUB PopFileInitialize (BYVAL hWnd&)
    STATIC szFilter AS ASCIIZ * 64,_
           szDefExt AS ASCIIZ * 5,_
           init&
    
    IF init& = 0 THEN
      szFilter = "*.HTM"   + CHR$(0) + "*.htm" + CHR$(0) + _
                 "*.DOC"   + CHR$(0) + "*.doc" + CHR$(0) + _
                 "*.PDF"   + CHR$(0) + "*.pdf" + CHR$(0) + _
                 "All Files (*.*)" + CHR$(0) + "*.*"   + CHR$(0) + CHR$(0)
      szDefExt = "htm"
      init& = -1
    END IF
    
    ofn.lStructSize       = SIZEOF(ofn)
    ofn.hWndOwner         = hWnd&
    ofn.hInstance         = %NULL
    ofn.lpstrFilter       = VARPTR(szFilter)
    ofn.lpstrCustomFilter = %NULL
    ofn.nMaxCustFilter    = 0
    ofn.nFilterIndex      = 0
    ofn.lpstrFile         = %NULL
    ofn.nMaxFile          = %MAX_PATH
    ofn.lpstrFileTitle    = %NULL
    ofn.nMaxFileTitle     = %MAX_FNAME + %MAX_EXT
    ofn.lpstrInitialDir   = %NULL
    ofn.lpstrTitle        = %NULL
    ofn.Flags             = 0 '%OFN_NODEREFERENCELINKS
    ofn.nFileOffset       = 0
    ofn.nFileExtension    = 0
    ofn.lpstrDefExt       = VARPTR(szDefExt)
    ofn.lCustData         = 0
    ofn.lpfnHook          = %NULL
    ofn.lpTemplateName    = %NULL

END SUB

FUNCTION PopFileOpenDlg& (BYVAL hWnd&, szFilName AS ASCIIZ, szTitleName AS ASCIIZ)
    
    LOCAL rc AS RECT
  
    CALL GetWindowRect (hWnd&, rc)
    Wdth& = ((rc.nRight - rc.nLeft) - 428) \ 2 
    Hght& = ((rc.nBottom - rc.nTop) - 266) \ 2 
    x& = rc.nLeft + wdth&
    y& = rc.nTop + Hght&
    hTmp& = CreateWindow("STATIC", "", %WS_POPUP, X&, Y&, 0, 0, hWnd&, 0, hInst&, 0)

    ofn.hWndOwner         = hTmp&
    ofn.lpstrFile         = VARPTR(szFilName)
    ofn.lpstrFileTitle    = VARPTR(szTitleName)
   'ofn.Flags             = %OFN_HIDEREADONLY OR %OFN_CREATEPROMPT
    ofn.Flags             = %OFN_FILEMUSTEXIST + %OFN_NODEREFERENCELINKS + _
                            %OFN_NOCHANGEDIR + %OFN_HIDEREADONLY

    FUNCTION = GetOpenFileName (ofn)

    CALL DestroyWindow(hTmp&)

END FUNCTION

SUB UserChoice(urlz AS ASCIIZ) ' Display the requested url

    LOCAL vflags AS VARIANT
    LOCAL vtargetframename AS VARIANT
    LOCAL vpostdata AS VARIANT
    LOCAL vheader AS VARIANT

    pActiveX??? = gActiveX???
  
    IF pActiveX??? THEN

       CALL JASetOptionalParameter(vflags)
       CALL JASetOptionalParameter(vtargetframename)
       CALL JASetOptionalParameter(vpostdata)
       CALL JASetOptionalParameter(vheader)

       CALL IWebBrowser_Navigate(pActiveX???, _
                                 JASetASCIIZToBSTR(url???, urlz), _
                                 vflags, _
                                 vtargetframename, _
                                 vpostdata, _
                                 vheader)
    
       gActiveX??? = pActiveX??? ' Set the global gActiveX??? requested to print

    END IF
  
    CALL SysFreeString(url???)
    
END SUB

SUB GoBack() ' Display previous page

    IF gActiveX??? THEN CALL IWebBrowser_GoBack(gActiveX???)

END SUB

SUB PrintIt()

    LOCAL vIn AS VARIANT
    LOCAL vOut AS VARIANT
    
    IF gActiveX??? = 0 THEN EXIT SUB

  ' Access the IWebBrowser2 interface exposed by the WebBrowser OCX
    pIWebBrowser2??? = 0
    
    CALL IUnknown_QueryInterface(gActiveX???, IID_IWebBrowser2, VARPTR(pIWebBrowser2???))
    
    IF pIWebBrowser2??? THEN
       CALL JASetOptionalParameter(vIn)
       CALL JASetOptionalParameter(vOut)

     ' Invoke the IWebBrowser ExecWB method, to print the current document (%OLECMDID_OLECMDID_PRINT)
     ' and let the user select the printer (%OLECMDEXECOPT_OLECMDEXECOPT_PROMPTUSER)
       CALL IWebBrowser2_ExecWB(pIWebBrowser2???, _
                                %OLECMDID_OLECMDID_PRINT, _
                                %OLECMDEXECOPT_OLECMDEXECOPT_PROMPTUSER, _
                                vIn, vOut)

     ' Release the IWebBrowser2 interface
       CALL IUnknown_Release(pIWebBrowser2???)

       CALL VariantClear(vIn)
       CALL VariantClear(vOut)
    END IF
 
END SUB

SUB GoForward() ' Display next page

    IF gActiveX??? THEN CALL IWebBrowser_GoForward(gActiveX???)
    
END SUB

FUNCTION JAEventCallBack& (BYVAL dwCookie AS DWORD, BYVAL hEvent&, BYVAL dwCustData AS DWORD) EXPORT

    LOCAL ControlName AS ASCIIZ * 256
    LOCAL EventName AS ASCIIZ * 256
    LOCAL par AS VARIANT

    CALL VariantInit(par)

    pActiveX??? = JAGetEventSenderDispatch(hEvent&)
    CALL JAGetControlName(pActiveX???, %JAHANDLE_PUNK, ControlName)

    IF ControlName = "Explorer1" THEN
       CALL JAGetEventName(hEvent&, EventName, SIZEOF(EventName))
       IF EventName = "StatusTextChange" THEN
	  CALL JAGetEventNamedParameterValue(hEvent&, "Text", par)
	  StatusMsg$ = " " + JAGetVariantTextContent(par)
          CALL skSetCTLText(hStatus&, StatusMsg$)
       END IF
    END IF

    CALL JAReleaseDispatch(pActiveX???)

    CALL VariantClear(par)
    
END FUNCTION

FUNCTION WndProc& (BYVAL hWnd&, BYVAL Msg&, BYVAL wParam&, BYVAL lParam&) EXPORT

    LOCAL rc AS RECT
    LOCAL ps AS PAINTSTRUCT

    LOCAL szFileName  AS ASCIIZ * %MAX_PATH
    LOCAL szTitleName AS ASCIIZ * (%MAX_FNAME + %MAX_EXT)
    
    STATIC LastDir$, UserInput$

  ' ------------------------------------------------------------------------------  
  ' Let the "Skin Egine" do the hard work for us...   
  ' ------------------------------------------------------------------------------  
  ' Ret& <> 0 means ---> Skin Engine did the job thus leave from here.
    Ret& = skGetMessage(hWnd&, Msg&, wParam&, lParam&) ' Call the Skin Engine !!!
    IF Ret& THEN FUNCTION = Ret&: EXIT FUNCTION        
  ' ------------------------------------------------------------------------------  
    
    SELECT CASE Msg&

    CASE %WM_PAINT
         SELECT CASE hWnd&
         CASE hCTL&         
            CALL GetClientRect(hWnd&, rc)
            Xin& = rc.nRight: Yin& = rc.nBottom
            hDC& = BeginPaint(hWnd&, ps)
            CALL skTileBlt(hDC&, 0, 0, Xin&, Yin&, skCtlBack)
            CALL EndPaint(hWnd&, ps)
         END SELECT       

    CASE %WM_SYSCOMMAND

	 IF wParam& = %SC_CLOSE THEN

            DIM cXY AS POINTAPI
	    CALL ShowWindow(hFrame&, %SW_RESTORE)
	    CALL GetWindowRect (hFrame&, rc)
	    Wdth& =  rc.nRight - rc.nLeft
	    Hght& = rc.nBottom - rc.nTop
            cXY.X = 0: cXY.Y = 0: CALL ClientToScreen(hFrame&, cXY)
	    CALL Config(cXY.X, cXY.Y, Wdth&, Hght&, 1)

            CALL PostQuitMessage(0)
	    FUNCTION = 1: EXIT FUNCTION

	 ELSEIF wParam& = 0 THEN

            tNotify$ = skAuthor$ + "||ZAP Image solution|http://www.zapsolution.com|e-mail: pterrier@infonie.fr|| copyright " + RIGHT$(DATE$, 4) + " Patrice Terrier|All rights reserved."
	    sk.Icon = LoadIcon(hInst&, "PROGRAM")
	    sk.Edge = %EDGE_ETCHED
	    sk.Just = %SK_CENTERED
	    sk.Effect = %SK_CENTERED
            sk.Print3D = %SK_3DOUT
            sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
            sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
   	  ' UseButton$ = "Button1|Button2|Button3"  
	    UseButton$ = "" ' Uses the default "ok" button

            CALL skMsgBox(hFrame&, skCaptionFont, skGetCTLText(hFrame&), tNotify$, UseButton$, sk)

	 END IF

    CASE %WM_COMMAND

         wP& = LOWRD(wParam&)

	 IF skMacte$(wP&, Mact$()) = "END" THEN
	    CALL SendMessage (hWnd&, %WM_SYSCOMMAND, %SC_CLOSE, lParam&)
	    FUNCTION = 1: EXIT FUNCTION
	 END IF

	 SELECT CASE wP&
	 
	 CASE 1                                        ' Show previous page.
	      CALL GoBack
	 CASE 2                                        ' Print current page.
	      CALL PrintIt   
	 CASE 3                                        ' Display next page.
	      CALL GoForward
         CASE 101                                      ' Display user choise.
              IF LEN(LastDir$) = 0 THEN LastDir$ = zTruePath
              zTmp = RTRIM$(LastDir$, "\")
              ofn.lpstrInitialDir = VARPTR(zTmp)
              IF PopFileOpenDlg(hFrame&, szFileName, szTitleName) THEN
                 CALL skSetCTLText(hStatus&, szTitleName)
                 CALL UserChoice(szFileName)
                 FullName$ = szFileName
                 CALL skSplitN(FullName$, LastDir$, FilName$)
              END IF
	 CASE 103                                       ' Navigate to URL.
              Caption$ = cfgStr$(6)
              tNotify$ = cfgStr$(7)
              sk.Icon = LoadIcon(hInst&, "PROGRAM")
              sk.Edge = %EDGE_ETCHED
              sk.Just = %SK_CENTERED
              sk.Effect = %SK_MARQUEE
              sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
              sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
              sk.Print3D = %SK_3DOUT'IN
              sk.Isize = 255  ' Max length of input size
              sk.Iwidth = 200 ' Pixel width of input field
              sk.ButFocus = 1
              sk.ButEscape = 2
              sk.Tile = 1
              IF skInputBox(hFrame&, skDefaultFont, Caption$, tNotify$, cfgStr$(8), UserInput$, sk) = 1 THEN
                 szFileName = UserInput$
                 CALL skSetCTLText(hStatus&, szFileName)
                 CALL UserChoice(szFileName)
              END IF
	 CASE 105                                       ' About...
              szTitleName = "SKWEBBR.HTM"
              szFileName = zTruePath + szTitleName
              IF skExist(szFileName) THEN
                 CALL skSetCTLText(hStatus&, szTitleName)
                 CALL UserChoice(szFileName)
              END IF
         CASE 201                                       ' Gold skin
              szTitleName = "GOLD.HTM"
              szFileName = zTruePath + szTitleName
              IF skExist(szFileName) THEN
                 CALL skSetCTLText(hStatus&, szTitleName)
                 CALL UserChoice(szFileName)
              END IF
         CASE 202                                       ' Wood skin
              szTitleName = "WOOD.HTM"
              szFileName = zTruePath + szTitleName
              IF skExist(szFileName) THEN
                 CALL skSetCTLText(hStatus&, szTitleName)
                 CALL UserChoice(szFileName)
              END IF
         CASE 203                                       ' Stone skin
              szTitleName = "STONE.HTM"
              szFileName = zTruePath + szTitleName
              IF skExist(szFileName) THEN
                 CALL skSetCTLText(hStatus&, szTitleName)
                 CALL UserChoice(szFileName)
              END IF
         CASE 204                                       ' Chrome skin
              szTitleName = "CHROME.HTM"
              szFileName = zTruePath + szTitleName
              IF skExist(szFileName) THEN
                 CALL skSetCTLText(hStatus&, szTitleName)
                 CALL UserChoice(szFileName)
              END IF
         END SELECT

    END SELECT

    FUNCTION = DefWindowProc(hWnd&, Msg&, wParam&, lParam&)

END FUNCTION


FUNCTION WinMain (BYVAL hInstance     AS LONG, _
		  BYVAL hPrevInstance AS LONG, _
		  lpCmdLine           AS ASCIIZ PTR, _
		  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL rc          AS RECT
    LOCAL wc          AS WndClassEx
    LOCAL szClassName AS ASCIIZ * 32

'--------------------------------------------------------------------------------
'   This code is needed only when using JAOCXCT20.DLL  
'--------------------------------------------------------------------------------
    LOCAL urlz        AS ASCIIZ * 512
    CALL InitSHDOCVWGUIDs()
'--------------------------------------------------------------------------------

    CALL skSplitN(skExeName$, TruePath$, TrueName$)

    zTruePath = TruePath$
    hInst& = hInstance&
    hFont& = skDefaultFont&

    ScrWidth& = GetSystemMetrics(%SM_CXSCREEN)
    ScrHeight& = GetSystemMetrics(%SM_CYSCREEN)

    ConfigFile$ = TruePath$ + EXTRACT$(TrueName$, ".") + ".SYS"
    IF NOT skExist(ConfigFile$) THEN
       nNotify$ = ConfigFile$ + " missing !"
       sk.Icon = LoadIcon(%NULL, BYVAL %IDI_QUESTION)      
       sk.Edge = %EDGE_ETCHED
       sk.Just = %SK_CENTERED
       sk.Effect = %SK_CENTERED
       sk.Fore = 128
       sk.Back = GetSysColor(%COLOR_MSGBOX)
       sk.Tile = 1
       CALL skMsgBox(0, hFont&, "SKDEMO", nNotify$, "", sk)
       FUNCTION = 2 ' ERROR_FILE_NOT_FOUND
       EXIT FUNCTION
    END IF

    hIcon& = LoadIcon(hInstance&, "PROGRAM")

'--------------------------------------------------------------------------------
'   Skin Engine. 
'--------------------------------------------------------------------------------
    REDIM PopMnu$(0), Mact$(0, 0), cfgStr$(0)
  ' Read the dynamic menu and related actions from the ASCII.SYS file  
    CALL skReadM(ConfigFile$, BarMnu$, PopMnu$(), Mact$(), Done&)
  
  ' Get the API menu handle (must be done before creation of menu container)
    hMenu& = skMenu&(BarMnu$, PopMnu$(), Mact$())
    
  ' Get the dynamic string messages from the ASCII.SYS file  
    CALL skReadStr(ConfigFile$, cfgStr$(), Done&)
'--------------------------------------------------------------------------------
  
  ' Retrieves last user window coordinates from the config file
    CALL Config(x&, y&, xFrame&, yFrame&, 0)

    zTmp = EXTRACT$(TrueName$, ".")
    szClassName = "SKINSDI"
    Style& = %CS_HREDRAW OR %CS_VREDRAW
    
    wc.cbSize        = SIZEOF(wc)
    wc.style         = Style&
    wc.lpfnWndProc   = CODEPTR(WndProc)
    wc.cbClsExtra    = 0
    wc.cbWndExtra    = 0
    wc.hInstance     = hInst&
    wc.hIcon         = %NULL
    wc.hCursor       = %NULL ' LoadCursor(%NULL, BYVAL %IDC_ARROW)
    wc.hbrBackground = %NULL ' Don't paint the class window background
    wc.lpszMenuName  = %NULL
    wc.lpszClassName = VARPTR(szClassName)
    wc.hIconSm       = LoadIcon(hInst&,"PROGRAM")

    CALL RegisterClassEx(wc)
 
'--------------------------------------------------------------------------------
'   Skin Engine
'--------------------------------------------------------------------------------
'   Tells the engine it should use 
    CALL skWindowStyle(%SK_MINIMIZEBOX OR _        ' MINIMIZEBOX button 
                       %SK_CLOSEBOX OR _           ' CLOSEBOX button
                       %SK_MAXIMIZEBOX OR _        ' MAXIMIZEBOX button
                       %SK_DOCKBOX OR _            ' DOCKBOX button
                       %SK_STATUSBAR)              ' STATUSBAR bottom status bar

'   Tell the engine the maximum size allowed         
    CALL skSetMaxSize(xFrame&, yFrame&, ScrWidth&, ScrHeight&)
'--------------------------------------------------------------------------------
    
    Style& = %WS_POPUP OR %WS_SYSMENU' OR %WS_CLIPCHILDREN
    StyleEx& = 0
    hFrame& = CreateWindowEx(StyleEx&, _
                          szClassName, _           ' window class name
                          zTmp, _                  ' window title
                          Style&, _                ' window style
                          x&, _                    ' initial x position
                          y&, _                    ' initial y position
                          xFrame&, _               ' initial x size
                          yFrame&, _               ' initial y size
                          %NULL, _                 ' parent window handle
                          %NULL, _                 ' window menu handle
                          hInst&, _                ' program instance handle
                          BYVAL %NULL)             ' creation parameters
  
'--------------------------------------------------------------------------------
'   Skin Engine
'--------------------------------------------------------------------------------
  ' Create control holder
    hCTL& = skHolder(hFrame&, "SKHOLDER", 0, 0, CODEPTR(WndProc))
    
  ' Create menu container (hMenu& handle must exist first, see above)
    hCTLmenu& = skHolder(hFrame&, "SKMENU", 0, 0, CODEPTR(WndProc))
    
  ' Create the status bar window %SK_STATUSBAR must be specified
    hStatus& = skStatusWindow(hFrame&, "")      ' in the skWindowStyle function.
'--------------------------------------------------------------------------------

    txButPrev$ = CHR$(51)
    txButPrint$ = cfgStr$(5)
    txButNext$ = CHR$(52)

    Fmarlett& = skMarlett(15)
    ButWidth& = 39

    xOfs& = 22 
    yOfs& = 5 

    hBut1& = skBut3D&(hCTL&, txButPrev$, Fmarlett&, xOfs&, yOfs&, ButWidth&, 20, 1, sk)
    CALL skButtonTip(hCTL&, hBut1&, cfgStr$(2))
    CALL skTabStop(hBut1&)

    hBut2& = skBut3D&(hCTL&, txButPrint$, skDefaultFont, xOfs& + ButWidth& + 3, yOfs&, ButWidth&, 20, 2, sk)    
    CALL skButtonTip(hCTL&, hBut2&, cfgStr$(3))
    CALL skTabStop(hBut2&)

    hBut3& = skBut3D&(hCTL&, txButNext$, Fmarlett&, xOfs& + (ButWidth& + 3) * 2, yOfs&, ButWidth&, 20, 3, sk)
    CALL skButtonTip(hCTL&, hBut3&, cfgStr$(4))
    CALL skTabStop(hBut3&)

    CALL skDeleteObject(Fmarlett&)
        
    CALL GetClientRect(hCTL&, rc)
    
'--------------------------------------------------------------------------------
'   This code fires the JAOCX engine from Philippe 
'--------------------------------------------------------------------------------

    CALL JACreateControl(hCTL&, "Explorer1", _
                         30, 30, rc.nRight - 60, rc.nBottom - 60, _
                         "ProgID:Shell.Explorer.2", 1, pActiveX???)

    CALL JASetControlResizeStyle(pActiveX???, %JAHANDLE_PUNK, _
                                 %JARESIZESTYLE_X2RIGHT OR %JARESIZESTYLE_Y2BOTTOM)

  ' Connect to the events fired by the OCX instance to the JAEventCallBack callback.
    CALL JASubscribeEvents(pActiveX???, CODEPTR(JAEventCallBack), 1)

    gActiveX??? = pActiveX??? ' Set the global gActiveX??? requested to print

  ' Use this URL to browse a valid Internet Web Site.
   'urlz="http://www.zapsolution.com"
   
  ' Use this to display and edit a WinWord document.  
   'urlz="file://" + TruePath$ + "ZAPDOCUS.DOC" 

  ' Use this to display and edit a EXCELS spreadsheet.  
   'urlz="file://" + TruePath$ + "WORLD.XLS" 
  
  ' Use this to display a Adobe Acrobat PDF file.  
   'urlz="file://" + TruePath$ + "ZAPDOC.PDF"

  ' Use this to display a VISIO file.  
   'urlz="file://J:\VISIO45\Samples\Database\sample~1.vsd"

  ' Use this to display a HTML help file.  
    urlz="file://" + TruePath$ + "SKWEBBR.HTM"

    Cline$ = COMMAND$
    IF LEN(Cline$) THEN
       IF skExist(Cline$) THEN 
          urlz = "file://" + Cline$
       ELSE
          urlz = Cline$
       END IF
    END IF

    CALL UserChoice(urlz)    
'--------------------------------------------------------------------------------

    CALL skSetCTLtext(hFrame&, cfgStr$(1))

    CALL PopFileInitialize (hFrame&) ' Initialize file selector
   
    CALL ShowWindow(hFrame&, %SW_SHOW)
    CALL UpdateWindow(hFrame&)

    WHILE GetMessage(Msg, %NULL, 0, 0)
      
     ' Let the Skin Engine handle the TAB key and ALT keys for the menu bar
     ' and some other stuffs as well (like animations)
       IF skDialogMessage(hFrame&, Msg) = %FALSE THEN
          TranslateMessage Msg
          DispatchMessage Msg
       END IF       
       
    WEND

  ' Release the OCX instance
    CALL JADeleteControl(pActiveX???)

    FUNCTION = msg.wParam

END FUNCTION

SUB Config (x&, y&, Wdth&, Hght&, BYVAL Action?)
'
' IF Action? = 0  read frame coordinates
' IF Action? <> 0 save frame coordinates

    CALL skSplitN(skExeName, TruePath$, TrueName$)
    IniFile$ = TruePath$ + EXTRACT$(TrueName$, ".") + ".CFG"

    IF Action? = 0 THEN          ' Read x y frame coordinates
       IF skExist(IniFile$) THEN
	  ErrCode& = skFOpen&(IniFile$, 0, 0, hFile&)
	  IF ErrCode& = 0 THEN Size& = skFlof(hFile&)
       END IF
       IF Size& THEN
	  Buff$ = SPACE$(Size&)
	  ErrCode& = skFGet(hFile&, Buff$)
	  x& = MAX(CVI(MID$(Buff$, 1, 2)), 0)
	  y& = MAX(CVI(MID$(Buff$, 3, 2)), 0)
	  Wdth& = MAX(CVI(MID$(Buff$, 5, 2)), skXmini)
	  Hght& = MAX(CVI(MID$(Buff$, 7, 2)), skYmini)
       ELSE
	  Wdth& = 600: Hght& = 400
          x& = MAX&((ScrWidth& - Wdth&) \ 2, 0)
          y& = MAX&((ScrHeight& - Hght&) \ 2, 0)
       END IF
    ELSE                        ' Save x y frame coordinates
       CALL skKillFile(IniFile$)
       ErrCode& = skFOpen&(IniFile$, 1, 1, hFile&)
       IF ErrCode& = 0 THEN
	  Buff$ = MKI$(x&) + MKI$(y&) + MKI$(Wdth&) + MKI$(Hght&)
	  ErrCode& = skFPut(hFile&, Buff$)
       END IF
    END IF
    CALL skFClose(hFile&)
    Buff$ = ""

END SUB
